--------------------------------------------------------------------------------
-- CREATE TABLE
CREATE TABLE log_dxt_odbc (
    action                         VARCHAR2(1)
  , rec_date                       DATE
  , rec_user                       VARCHAR2(240)
  , odbc_name                      VARCHAR2(240)
  , odbc_user                      VARCHAR2(240)
  , odbc_pass                      VARCHAR2(240)
  , comments                       VARCHAR2(2000)
);

COMMENT ON TABLE  log_dxt_odbc IS 'ODBCڑ(LOG)';
COMMENT ON COLUMN log_dxt_odbc.action                         IS 'ANV';
COMMENT ON COLUMN log_dxt_odbc.rec_date                       IS 'XV';
COMMENT ON COLUMN log_dxt_odbc.rec_user                       IS 'XV';
COMMENT ON COLUMN log_dxt_odbc.odbc_name                      IS 'ODBC';
COMMENT ON COLUMN log_dxt_odbc.odbc_user                      IS 'ODBC[U[';
COMMENT ON COLUMN log_dxt_odbc.odbc_pass                      IS 'ODBCpX[h';
COMMENT ON COLUMN log_dxt_odbc.comments                       IS 'Rg';

--------------------------------------------------------------------------------
-- CREATE TRIGGER
CREATE OR REPLACE TRIGGER log_dxt_odbc
AFTER INSERT OR DELETE OR UPDATE ON dxt_odbc
FOR EACH ROW
DECLARE
    rec_log log_dxt_odbc %ROWTYPE;
BEGIN
    --
    rec_log := NULL;
    --
    IF INSERTING THEN
        rec_log.action := 'I';
    ELSIF UPDATING THEN
        rec_log.action := 'U';
    ELSIF DELETING THEN
        rec_log.action := 'D';
    END IF;
    --
    IF INSERTING OR UPDATING THEN
        rec_log.rec_date  := :NEW.rec_date  ;
        rec_log.rec_user  := :NEW.rec_user  ;
        rec_log.odbc_name := :NEW.odbc_name ;
        rec_log.odbc_user := :NEW.odbc_user ;
        rec_log.odbc_pass := :NEW.odbc_pass ;
        rec_log.comments  := :NEW.comments  ;
    ELSE
        rec_log.rec_date  := SYSDATE        ;
        rec_log.rec_user  := :OLD.rec_user  ;
        rec_log.odbc_name := :OLD.odbc_name ;
        rec_log.odbc_user := :OLD.odbc_user ;
        rec_log.odbc_pass := :OLD.odbc_pass ;
        rec_log.comments  := :OLD.comments  ;
    END IF;
    --
    INSERT INTO log_dxt_odbc VALUES rec_log;
    --
END;
/
